this.name        = "Hyperdrives"; 
this.author      = "Redspear"; 
this.copyright   = "2016 Redspear";
this.licence     = "CC BY-NC-SA 4.0"; 
this.description = "Variable hyperdrives and jump ranges for player ships"; 
this.version     = "0.5";

"use strict";

// determine player ship hyperdrive range

this.startUp = this.playerBoughtNewShip = this.equipmentAdded = this.equipmentDamaged = this.equipmentRemoved = this.equipmentRepaired = function()
{
	//'archaic' tech ships defined as follows	
	//if(player.ship.dataKey == "python-player")
	//	{var fuelBase = 3.5;}//these ships granted a base range of 2.5LY
	
	//'low' tech ships defined as follows		
	//if (player.ship.dataKey == "anaconda-player" || player.ship.dataKey == "asp-player" || player.ship.dataKey == "cobramk1-player")
	//	{var fuelBase = 4;}//these ships granted a base range of 4.5LY
	
	//'standard' tech ships defined as follows
	//if (player.ship.dataKey == "morayMED-player" || player.ship.dataKey == "moray-player" || player.ship.dataKey == "adder-player" || player.ship.dataKey == "boa-player")
	//	{var fuelBase = 4.5;}//these ships granted a base range of 3.5LY
	
	//'high' tech ships defined as follows
	//if (player.ship.dataKey == "cobra3-player" || player.ship.dataKey == "boa-mk2-player")
	//	{var fuelBase = 5;}//these ships granted a base range of 2.5LY
	
	//'state of the art' tech ships defined as follows	
	//if (player.ship.dataKey == "ferdelance-player" || player.ship.dataKey == "viper-interceptor-player" || player.ship.dataKey == "constrictor-player")
	//	{var fuelBase = 5.5;}//these ships granted a base range of 3.5LY
		
	//OXP ship range calculated as follows
	//if	(player.ship.dataKey != "cobra3-player" && player.ship.dataKey != "boa-player" && player.ship.dataKey != "constrictor-player" && player.ship.dataKey != "boa-mk2-player" && player.ship.dataKey != "anaconda-player" && player.ship.dataKey != "ferdelance-player" && player.ship.dataKey != "asp-player" && player.ship.dataKey != "python-player" && player.ship.dataKey != "viper-interceptor-player" && player.ship.dataKey != "moray-player" && player.ship.dataKey != "morayMED-player" && player.ship.dataKey != "cobramk1-player" && player.ship.dataKey != "adder-player")
	//	{var fuelBase = player.ship.energyRechargeRate +1;}

	
	//equipment modifiers (needs tidying)
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{this._rangeLimit = 7;
		this._fuelMalus = 0;}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{this._rangeLimit = 6.5;
		this._fuelMalus = 0;}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{this._rangeLimit = 6.5;
		this._fuelMalus = 0;}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{this._rangeLimit = 6;
		this._fuelMalus = 0;}		
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{this._rangeLimit = 6.5;
		this._fuelMalus = 0;}	

	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{this._rangeLimit = 6;
		this._fuelMalus = 0;}			
	
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{this._rangeLimit = 6.5;
		this._fuelMalus = 0;}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{this._rangeLimit = 6;
		this._fuelMalus = 0;}		
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{this._rangeLimit = 6;
		this._fuelMalus = 0;}	
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{this._rangeLimit = 5.5;
		this._fuelMalus = 0;}		
	
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{this._rangeLimit = 6;
		this._fuelMalus = 0;}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{this._rangeLimit = 5.5;
		this._fuelMalus = 0;}		
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{this._rangeLimit = 6;
		this._fuelMalus = 0;}	
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") === "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{this._rangeLimit = 5.5;
		this._fuelMalus = 0;}		

	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") === "EQUIPMENT_OK")
		{this._rangeLimit = 5.5;
		this._fuelMalus = 0;}
		
	if	(player.ship.equipmentStatus("EQ_ENERGY_UNIT") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_GAL_DRIVE") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_WORMHOLE_SCANNER") != "EQUIPMENT_OK" && player.ship.equipmentStatus("EQ_ADVANCED_NAVIGATIONAL_ARRAY") != "EQUIPMENT_OK")
		{this._rangeLimit = 5;
		this._fuelMalus = 0;}
			
	//max bonus is retained with any two of the above three items of equipment still working 
	//if (fuelBonus == 3)
	//	{var fuelBonus = 2;}			
			

	//if (player.ship.fuel > fuelLimit)
	//	{player.ship.fuel = fuelLimit;}
		
	this._fuelMalus = 0;

}

// represent range limits on navigation charts

this.guiScreenChanged = function(toGUI)
{
	var toggle = 0;
	
	if (toGUI == "GUI_SCREEN_SHORT_RANGE_CHART")
		{if (player.ship.fuel > _rangeLimit)
			{this._fuelMalus = player.ship.fuel - _rangeLimit;
			player.ship.fuel = _rangeLimit;}
		else
		{player.ship.fuel = player.ship.fuel}
	}
		
	if (toGUI != "GUI_SCREEN_SHORT_RANGE_CHART" && toGUI != "GUI_SCREEN_LONG_RANGE_CHART")	
		{player.ship.fuel = player.ship.fuel + _fuelMalus;
		this._fuelMalus = 0;}
}

// abort jump if range limit exceeded

this.playerStartedJumpCountdown = function(standard)
{
	//var jumpCheck = player.ship.targetSystem;
	//var jumpCheck = player.ship.nextSystem;
	
	if (System.infoForSystem(galaxyNumber, system.ID).distanceToSystem(System.infoForSystem(galaxyNumber, player.ship.nextSystem)) > _rangeLimit)
		{player.ship.cancelHyperspaceCountdown();
		// let player know what went wrong (or at least a clue)
		player.consoleMessage ("Present Hyperdrive Capability Insufficient");}
}